%
%          Modell for Bullheading
%
%
%
%
% vgass/vslam = Hastighet av slamfront/gassfront
% g       = Gravity constant
% pGM     = Trykk ved rett over gassen(Generert av tetthet til killmud)
% depthGC = Depth of gascoloum
% Tres    = Temperatur ved reservoar
% Zgass   = Gass konstant
% re      = 
% rw      = Hull radius
% Skin    =
% Pres    = Reservoar trykk [Bara]
% Pwf     = 
% Area    = Drainage area
% NrWells = Antall brnner i omrdet
% ViscGass= Viskositet til gassen [Centipoise]
% k       = Permeability [md]
% h       = Produksjonsomrde
%      


function[rhoKMud]=Bullheading(QSlam,QSlamMax,Pres,Area,NrWells,TVD,IDcasing,BitDia,tDetect,Skin,initialmuddensity,Loss,Metan1Etan2Propan3)

%
% Composition of kick
%

if Metan1Etan2Propan3==2

Molardensity=0.03007;   % [kg/mol] Antar Etan som kick fluid. Dersom 
viscGass=0.095; %Antatt at gassen er Etan
Zgass=0.955; %Antatt at gassen er Etan
elseif Metan1Etan2Propan3==1
Molardensity=0.016;   % [kg/mol] Antar Metan som kick fluid. Dersom 
viscGass=0.11;         % Antatt at gassen er Metan
Zgass=0.998;            % Antatt at gassen er Metan
    
else
Molardensity=0.04410;   % [kg/mol] Antar Propan som kick fluid. Dersom 
viscGass=0.080;         % Antatt at gassen er Propan
Zgass=0.9819;            % Antatt at gassen er Propan
end



%
%  Constants
%

re=sqrt(Area/NrWells); 

rw=BitDia/2; 
g=9.81;
Tres=(4+273+(3/100)*TVD);   % Antar at brnnen ligger p havet(4 grader celcius ved havbunnen).[Kelvin] : eventuelt om ikke br overflate temperaturen tas med.
Tst=273+15;                 % Standard temperatur (15 grader Celsius)
Pc=Pres;                    % Poretrykk i reservoar[bar]
h=10;                       % Estimert omrde hvor det produseres fra [m]
k=100;                      % Estimer permiabilitet i reservoaret [cp]
HeightGC=0;                 % HeightGC = Height GassColoum [m]
t=0;

R=8.3144621*10^(-5);


Apipe=(3.14*(IDcasing/2)^2);
vslam=QSlam/Apipe;



%
%   Forming Kick
%

HMudafterLoss=TVD*(1-Loss);

    while t<=tDetect
        
        t=t+1;
    

    KickPwf=initialmuddensity*g*HMudafterLoss*(10^(-5)); % Trykk p bunn av brnnen[Bar](Hydrostatisk)
    
    KickQGassST=((7.73*k*h*(Pc^2-KickPwf^2))/(Tres*viscGass*Zgass*(log(re/rw)-(3/4)+Skin)))/(60*60*24);

    KickQGassPwf=(KickQGassST*Tres*Zgass)/(KickPwf*Tst);

    vgass=KickQGassPwf/Apipe;
    
    RhoGass=((KickPwf*Molardensity)/(Tres*R));
   
    dv=-sqrt((((vgass^2)*RhoGass)-((vslam^2)*initialmuddensity))/(initialmuddensity));
    
    HeightTest=HMudafterLoss+HeightGC;
    
        if HeightGC>TVD      
            
        elseif HeightTest>=TVD 
            
            HMudafterLoss=HMudafterLoss+dv;
            HeightGC=HeightGC-dv;
        else
            HeightGC=HeightGC-dv;
          
        end
%     
%        plot(t,dv);
%        hold on;
       
    end  

    
if HeightGC>TVD             %Disse linjene tar hyde for at gasssylen ikke kan vre hyere enn selve hullet,
    HeightGC=TVD;           %og at slamsylen ikke kan ha negativ hyde.
end
if HMudafterLoss<0
    HMudafterLoss=0;
end



%
%   Bullheading
%
%



vslam=QSlamMax/Apipe;
rhoKMud=killmuddensity(TVD,Pc,HMudafterLoss,initialmuddensity); %Minimum tetthett som skaper BHP>Pc (Hydrostatisk)

v=dv; 

Mgass=(RhoGass*(v)^2)/Apipe;
Mslam=(rhoKMud*(vslam)^2)/Apipe;



l=0;
    while Mgass>Mslam && l<40000          %Srger for at momentet til slammet overstiger det som genereres av gassen(Her med 2,5%).
      
        l=l+1;
        Mgass=RhoGass*(v^2)/Apipe;       
        Mslam=rhoKMud*(vslam^2)/Apipe;
        
        if Mgass>=Mslam
           rhoKMud=rhoKMud+0.1;           % Kan vre aktuelt  justere faktoren her for  redusere beregningstiden.
        end
        
        dM=Mgass/Mslam;
      %  plot(l,dM);
        hold on;
        
    end



    while 0<HeightGC && t<100000

               t=t+1; %Teller antall loops/sekunder [s]
        
       AnnularPLoss=((1.4327*10^(-7)*0.00834540445*rhoKMud*TVD*(1/0.3048)*(dv*(1/0.00508))^2)/(IDcasing*(1/0.0254)))*0.0689475729;
           
       Phyd=(((TVD-HMudafterLoss-HeightGC)*rhoKMud)+(HeightGC*RhoGass)+(initialmuddensity*HMudafterLoss))*g*(10^(-5))+1.013;  
       
    
       ECD=(AnnularPLoss/(TVD*g));
       Pwf=Phyd+ECD;
              
       
       QGassST=((7.73*k*h*((Pc^2)-(Pwf^2)))/(Tres*viscGass*Zgass*(log(re/rw)-(3/4)+Skin)))/(60*60*24); 
                                                                                             
       QGassRes=(QGassST*Tst*Zgass)/(Pc*(Tres));                                            
       
       RhoGass=((Molardensity*Pwf)/(Tres*R));
       vgass=QGassRes/Apipe;
            
       
       dv=sqrt((((vslam)^2*rhoKMud)-(vgass^2*RhoGass))/(rhoKMud));%Total hastighet nr Pwf<BHP
       
       
       HeightGC=HeightGC-dv;
       
       if HeightGC<0
           HeightGC=0;
       end
       
      
       plot(t,dv,'g');
       plot(t,vslam,'r');
       xlabel('Tid [s]');           % NB! Juster label ettersom hva som plottes.
       ylabel('Hastighet [m/s]');
       hold on;
      
      
         
    end

end
